<template>
    <view class="container" style="paddingBottom:1rpx;">
      <u-navbar
			leftIconSize="40rpx"
			leftIconColor="#333333"
			title="股票账户管理"
		>
		</u-navbar>
      <view class="section">
        <view class="section-title">{{ title}}</view>
        <view class="form-view">
          <u--form labelPosition="left" :model="form" :rules="rules" ref="uForm" label-width="auto"
            :labelStyle="{ color: '#333333', fontSize: '30rpx' }">
            <u-form-item label="股票账户名称" prop="name" required >
              <u--input v-model="form.name"  placeholder="请填写股票账户名称"
                inputAlign="right" border="none"></u--input>
            </u-form-item>
          
            <u-form-item label="账号" prop="code" required >
              <u--input v-model="form.code"  placeholder="请填写账号"
                inputAlign="right" border="none"></u--input>
            </u-form-item>
            <u-form-item label="密码" prop="password"  >
              <u--input v-model="form.password"  placeholder="请填写密码"
                inputAlign="right" border="none"></u--input>
            </u-form-item>
            <u-form-item label="关联储蓄卡" prop="bankNameCode"  @click="handleDebitCard">
              <u--input v-model="form.bankNameCode" disabled disabledColor="#ffffff" placeholder="请选择关联储蓄卡"
                inputAlign="right" border="none"></u--input>
              <u-icon slot="right" name="arrow-down"></u-icon>
            </u-form-item>
            <u-form-item label="开户日期" prop="activationDate"  @click="selectDate()">
              <u--input v-model="form.activationDate" disabled disabledColor="#ffffff" placeholder="请选择开户日期" inputAlign="right" border="none"></u--input>
						<u-icon slot="right" name="arrow-right"></u-icon>
            </u-form-item>
          
            <u-form-item label="手续费" prop="commission" >
              <u--input v-model="form.commission"  placeholder="请填写手续费"
                inputAlign="right" border="none"></u--input>
            </u-form-item>
            <u-form-item label="备注" prop="remark"  labelPosition="top">
              <u--textarea v-model="form.remark" placeholder="请填写备注" border="none" autoHeight inputAlign="right" count
                maxlength="20000" style="padding:18rpx 0;"></u--textarea>
            </u-form-item>
          </u--form>
          <view class="form-btn">
            <u-button type="primary" text="提交" @click="submit"></u-button>
          </view>
        </view>
      </view>
      <u-toast ref="uToast"></u-toast>
      <u-picker itemHeight="88" :show="showDebitCard" :columns="debitCardList" keyName="nameCodeAvailableLimit" @cancel="handleDebitCardCancel"
      @confirm="handleDebitCardConfirm"></u-picker>
        <u-datetime-picker
			:show="datePickShow"
			mode="date"
      ref="createTimeRef" 
			@cancel="datePickShow=false"
			@confirm="datePickConfirm"
			itemHeight="88"
		></u-datetime-picker>
    </view>
  </template>
  
  <script setup>
import { getFutureStocks, addFutureStocks, updateFutureStocks } from '@/api/invest/futureStocks'
  import { listAccounts } from '@/api/invest/accounts'
  const { proxy } = getCurrentInstance()
  import dayjs from 'dayjs'
  import {onLoad,onReady} from "@dcloudio/uni-app";
    // 计算属性与监听属性是在vue中而非uniap中 需要注意！！！
import {reactive ,toRefs,ref,computed ,getCurrentInstance }from "vue";
const datePickShow = ref(false)
const showDebitCard = ref(false)
const title = ref("股票账户管理")
const debitCardList = ref([])
const dateType = ref(1)
const data = reactive({
  form: {
    id: null,
    name: null,
    type: '2',
    code: null,
    password: null,
    tradingCenterCode: null,
    tradingCenterPassword: null,
    fundPassword: null,
    commission: null,
    bond: null,
    debitCard: null,
    activationDate: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    delFlag: null,
    remark: null
  },
  queryDebitCardParams: {
    pageNum: 1,
    type: '1',
    state: '1',
    pageSize: 1000
  },
  // dateType:'1',
  rules: {
          name: [{ type: 'string', required: true, message: '股票账户名称不能为空', trigger: ['change', 'blur'] }],
          code: [{ type: 'string', required: true, message: '账号不能为空', trigger: ['change', 'blur'] }],
  }
})
const { form, queryDebitCardParams, rules} = toRefs(data)

onLoad((option) => {
       form.value.id = option.id
       if(form.value.id!=null){
        title.value="股票账户管理-修改"
       }else{
        title.value="股票账户管理-新增"
       }
      getDict()
  })
  onReady(() => {
    form.value.activationDate = dayjs(new Date().getTime()).format("YYYY-MM-DD")
    form.value.effectiveDate = dayjs(new Date().getTime()).format("YYYY-MM-DD")
  })
  function  getDict() {
        // 类型
        listAccounts(queryDebitCardParams.value).then((response) => {
       debitCardList.value = [response.rows] 
       })
      
      if(form.value.id!=null){
        getFutureStocks(form.value.id).then(res => {
          form.value = res.data
        })
      }
  }

    function handleDebitCard() {
        if (debitCardList.value[0].length === 0) {
          proxy.$refs['uToast'].show({
            message: '结算卡为空  ', type: 'warning'
          })
        } else {
          showDebitCard.value = true
        }
     }
  function   handleDebitCardConfirm(e) {
       form.value.bankNameCode = e.value[0].nameCodeAvailableLimit
        form.value.debitCard = e.value[0].id
        showDebitCard.value = false    
  }
 function handleDebitCardCancel() {
       showDebitCard.value = false
    }
      function  selectDate(type) {
        dateType.value=type
				datePickShow.value = true
        proxy.$refs['createTimeRef'].innerValue = new Date().getTime()
			}
			function datePickConfirm(e) {
          form.value.activationDate = dayjs(e.value).format("YYYY-MM-DD")
				datePickShow.value = false
			}
      function submit() {
        proxy.$refs['uForm'].validate().then(() => {
          if (form.value.id != null) {
            updateFutureStocks(form.value).then(res => {
              proxy.$refs['uToast'].show({
              message: '修改成功', complete() {
                uni.navigateTo({ url: `/pages/work/base/stocks/list` })
              }
            })
          })
          }else {
            addFutureStocks(form.value).then(res => {
              proxy.$refs['uToast'].show({
              message: '新增成功', complete() {
                uni.navigateTo({ url: `/pages/work/base/stocks/list` })
              }
            })
          })
          }
        })
      }
  </script>
  
  <style lang="scss" scoped>
  .section {
    margin: 24rpx;
    padding: 16rpx 24rpx;
    background-color: #fff;
    border-radius: 8rpx;
  
    .section-title {
      width: 360rpx;
      color: #333333;
      line-height: 44rpx;
      font-size: 30rpx;
      border-left: 6rpx solid #2681FF;
      padding-left: 26rpx;
    }
  
    .form-view {
      padding: 20rpx 0rpx 0 10rpx;
  
      .form-btn {
        padding-top: 20rpx;
      }
    }
  }
  </style>